'***********************************************
'
' Uninstall Printer
'
' Date: 11/10/2008
' Version: 4.0
'
'***********************************************
Dim ArgObj
Dim BatchFile
Dim sCommand
Dim WshShell ' as object
Dim objEnv ' as collection
Dim sGetMyVar  ' as string
Dim sPrinterShutDown
Dim sPrinter
Dim sPrinter_list
Dim sPrinter_array
Dim sHID
Dim sHID_list
Dim sHID_array

' Get the Arguments object
Set ArgObj = WScript.Arguments

Set WshShell = WScript.CreateObject("WScript.Shell")
Set objEnv = WshShell.Environment("PROCESS")
Set objFileSystem = WScript.CreateObject("Scripting.FileSystemObject")

sPrinter_list = "EasyShare AIO 3040@" & _
               "EASYSHARE 5100 AiO Printer@" & _
               "EASYSHARE 5300 AiO Printer@" & _
               "EASYSHARE 5500 AiO Printer@" & _
               "KODAK 5100 AiO@" & _
               "KODAK 5300 AiO@" & _
               "KODAK 5500 AiO@" & _
               "KODAK 830@" & _
               "KODAK 3300 AiO@" & _               
               "KODAK ESP-3 AiO@" & _
               "KODAK ESP 5 AiO@" & _
               "KODAK ESP 7 AiO@" & _
               "KODAK ESP 9 AiO@" & _
               "KODAK ESP 3200 AiO@" & _
               "KODAK ESP 5200 AiO@" & _
               "KODAK ESP 3200 Series AiO@" & _
               "KODAK ESP 5200 Series AiO@" & _
               "KODAK ESP Office 4100 Series AiO@" & _
               "KODAK ESP Office 6100 Series AiO@" & _
               "ESPOffice 4100 Series AiO@" & _
               "ESPOffice 6100 Series AiO"

sHID_list  = "EastmanKodakCo_ABCD " & _
            "Eastman_Kodak_Compan2427 " & _ 
            "Eastman_Kodak_Compan05CC " & _
            "Eastman_Kodak_Compan0A83 " & _
            "Eastman_Kodak_Compan0Ae7 " & _
            "Eastman_Kodak_CompanCAC4 " & _
            "Eastman_Kodak_Compan0AE7 " & _
            "Eastman_Kodak_Compan0A83 " & _ 
            "Eastman_Kodak_Compan7C78 " & _
            "Eastman_Kodak_CompanEAEC " & _
            "Eastman_Kodak_Compan8CEC " & _
            "Eastman_Kodak_Compan880B " & _
            "Eastman_Kodak_Compan2067 " & _
            "Eastman_Kodak_Compan9580 " & _
            "Eastman_Kodak_Compan55FB " & _
            "Eastman_Kodak_Compan9492 " & _
            "Eastman_Kodak_Compan89C8 " & _
            "Eastman_Kodak_CompanA348 " & _
            "Eastman_Kodak_CompanD4A7 " & _
            "Eastman_Kodak_CompanB7A1 " & _
            "Eastman_Kodak_CompanFDE6 " & _
            "Eastman_Kodak_CompanFC64 " & _
            "Eastman_Kodak_Compan56CB " & _
            "Eastman_Kodak_CompanF0A9"


sPrinter_array = Split(sPrinter_list, "@")
sHID_array = Split(sHID_list, " ")

'Delete Printer and Driver
For Each sPrinter in sPrinter_array
    Call DeletePrinterDriver(sPrinter)
Next

' Vista - Remove Driver Store / Driver Package
For Each sHID in sHID_array
    Call DeletePackageViaOEM_INF(sHID)
Next

'Stop spooler
WshShell.Run "Net Stop Spooler",0,true
WshShell.Run "Net Start Spooler",0,true
WshShell.Run "Net Stop Spooler",0,true
WScript.Sleep 1000 ' Wait for complete clean up of spooler

'Delete Forms if Forms have changed.
Call DeleteFormRegEntrys

'Shutdown
Call ProcessTerminate("KODAKMDN.EXE")
Call ProcessTerminate("KODAKPRE.EXE")
Call ProcessTerminate("KODAKMUI.EXE")
Call ProcessTerminate("EKIJ5000MDN.EXE")
Call ProcessTerminate("EKIJ5000PRE.EXE")
Call ProcessTerminate("EKIJ5000MUI.EXE")
Call ProcessTerminate("EasyShare.EXE")

'Delete installed files if any still exist
Call DeleteFiles(sHID_array)

'Remove possible registry entires.
For Each sPrinter in sPrinter_array
    Call DeletePrinterRegEntry(sPrinter)
Next

Call DeletePPRRegEntry("KODAK Processor")
Call DeletePPRRegEntry("KODAK EASYSHARE 5000 Series All-in-One Printer")

Call DeleteLMRegEntry("KODAK Monitor")
Call DeleteLMRegEntry("KODAK EASYSHARE 5000 Series All-in-One Printer")

' Remove OEM INF files
For Each sHID in sHID_array
    Call DeleteOEM_INF(sHID)
Next

' Start Spooler
WshShell.Run "Net Start Spooler",0,true
WScript.Sleep 1000 ' Let spooler start up

'MsgBox "Driver Uninstalled!", 0, "KODAK EASYSHARE 5000 Series All-in-One Printer"

WScript.Quit

'***********************************************
' Function: DeletePrinterRegEntry
' Purpose:  Delete Printer Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeletePrinterRegEntry( strDriverName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & "\DsDriver\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & "\DsSpooler\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & "\PnPData\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & "\PrinterDriverData\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & ",0\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & ",1\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & ",2\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & ",3\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & ",4\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Printers\" & strDriverName  & ",5\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Drivers\Version-3\" & strDriverName & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Drivers\Version-3\" & strDriverName & "\"
    WshShell.RegDelete "HKCU\Printers\DevModePerUser\" & strDriverName 
    WshShell.RegDelete "HKCU\Printers\DevModes2\" & strDriverName
    On Error Goto 0
End Function

'***********************************************
' Function: DeletePPRRegEntry
' Purpose:  Delete Printer Processor Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeletePPRRegEntry ( strPPRName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows NT x86\Print Processors\" &  strPPRName & "\"
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Environments\Windows x64\Print Processors\" &  strPPRName & "\"
    On Error Goto 0
End Function

'***********************************************
' Function: DeleteLMRegEntry
' Purpose:  Delete Printer Processor Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeleteLMRegEntry ( strLMName )
    On Error Resume Next
    WshShell.RegDelete "HKLM\SYSTEM\CurrentControlSet\Control\Print\Monitors\" & strLMName & "\"
    WshShell.RegDelete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run\EKIJ5000StatusMonitor"
    WshShell.RegDelete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Run\KODAKIJStatusMonitor"
    On Error Goto 0
End Function

'***********************************************
' Function: TerminateProcess
' Purpose:  Terminates a process
' Input:      Name of process
'***********************************************
Private Function ProcessTerminate( strProcess )
    Dim colProcessList, objProcess

    On Error Resume Next   
    Set colProcessList = GetObject("Winmgmts:").ExecQuery _
        ("Select * from Win32_Process Where Name ='" & strProcess & "'")
    For Each objProcess in colProcessList
        objProcess.Terminate( )
    Next

    Set colProcessList = Nothing
    On Error Goto 0  
  
End Function

'***********************************************
' Function: DeletePackageViaOEM_INF
' Purpose:  Delete Package OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeletePackageViaOEM_INF( strDeleteOn )

    Dim oShell 
    Dim oShellExec, oStdOutputText, sText, iElement, aOS, sOS, sCommand, sPath

    Set oShell = CreateObject("Wscript.Shell") 
    Set oShellExec = oShell.Exec("%comspec% /c ver") 
    Set oStdOutputText = oShellExec.StdOut 
   
    Do While Not oStdOutputText.AtEndOfStream 
        sText = oStdOutputText.ReadLine 
        aOS = Array("Windows 95", "Windows 98", "Windows NT", "Windows 2000", "Windows XP", "Microsoft Windows [Version 5.0", "Microsoft Windows [Version 6.0") 
        For iElement = LBound(aOS) To UBound(aOS) 
            If InStr(sText, aOS(iElement)) <> 0 Then 
                If aOS(iElement) = "Microsoft Windows [Version 6.0" Then 
                        sOS = "Windows Vista" 
                ElseIf aOS(iElement) = "Microsoft Windows [Version 5.0" Then 
                        sOS = "Windows 2003" 
                Else 
                        sOS = aOS(iElement) 
                End If 
            End If 
        Next 
    Loop 

    Dim i
    Dim objFile
    Dim strText
    Dim strFile
    Dim strFilePNF
    Dim strCommand

    If sOS = "Windows Vista" Then
        For i = 0 to 999 Step 1
            strFile = objEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
            strFilePNF = objEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
            If objFileSystem.FileExists(strFile) then 	
                On Error Resume Next
                Set objFile = objFileSystem.OpenTextFile(strFile, 1)
                strText = objFile.ReadAll
                objFile.Close
                If InStr(1, strText, strDeleteOn, 1) <> 0 Then
                    strCommand= "pnputil.exe -f -d OEM" & i & ".INF"                            
                    WshShell.Run strCommand,0,true	
                End if
                On Error Goto 0
            End if
        Next
    End If

End Function

'***********************************************
' Function: DeleteOEM_INF
' Purpose:  Delete OEM#.INF
' Input:    String to find in OEM#.inf
'***********************************************
Private Function DeleteOEM_INF( strDeleteOn )
    Dim i
    Dim objFile
    Dim strText
    Dim strFile
    Dim strFilePNF
    For i = 0 to 999 Step 1
        strFile = objEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
        strFilePNF = objEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
        If objFileSystem.FileExists(strFile) then 	
            On Error Resume Next
            Set objFile = objFileSystem.OpenTextFile(strFile, 1)
            strText = objFile.ReadAll
            objFile.Close
            On Error Goto 0
            If InStr(1, strText, strDeleteOn, 1) <> 0 Then
                On Error Resume Next
                objFileSystem.DeleteFile strFile, true
                objFileSystem.DeleteFile strFilePNF, true
                On Error Goto 0
            End if
        End if
    Next
End Function

'***********************************************
' Function: DeleteTCPIPPort
' Purpose:  Delete Standard TCP/IP Port
' Input:    String to find in port name
'***********************************************
Private Function DeleteTCPIPPort( strDeleteOn )
    Dim i
    Dim objFile
    Dim strText
    Dim strFile
    Dim strFilePNF
    For i = 0 to 999 Step 1
        strFile = objEnv("SYSTEMROOT") & "\INF\OEM" & i & ".INF"
        strFilePNF = objEnv("SYSTEMROOT") & "\INF\OEM" & i & ".PNF"
        If objFileSystem.FileExists(strFile) then 	
            On Error Resume Next
            Set objFile = objFileSystem.OpenTextFile(strFile, 1)
            strText = objFile.ReadAll
            objFile.Close
            On Error Goto 0
            If InStr(1, strText, strDeleteOn, 1) <> 0 Then
                On Error Resume Next
                objFileSystem.DeleteFile strFile, true
                objFileSystem.DeleteFile strFilePNF, true
                On Error Goto 0
            End if
        End if
    Next
End Function

'***********************************************
' Function: DeleteFiles
' Purpose:  Deletes driver files
' Input:      None
'***********************************************
Private Function DeleteFiles ( sHID_array )
   Dim Prefixes_list
   Dim Directories_list
   Dim Files_list
   Dim sHID 
    
   Dim prefixes_array
   Dim prefix
   Dim directories_array
   Dim directory
   Dim files_array
   Dim i
   Dim path

   Prefixes_list    = "kodak ekij5000 ekij5100 ekij5300 ekij5500 " & _
                      "ekij3000 ekij830 ekij3300 ekijesp3 ekijesp5 " & _
                      "ekijesp7 ekijesp9 ekij3200 ekij5200 ekij4100 " & _
                      "ekij6100 ekijcoinst"
                      
   Directories_list = "w32x86 x64"
   Files_list       = "IJ.gpd  IJ.bud  IJ.ini  .gpd .bud .ini " & _
                      "IJ.chm  IJ.hlp  IJ.gid  .hlp .gid .chm " & _
                      "MDK.dll MDN.dll MDN.exe MUI.exe MUI.dll " & _
                      "PRE.exe PRE.dll PRE.chm PRE.hlp RES.dll " & _
                      "RIJ.dll RRS.dll SDK.dll UIP.dll"

   prefixes_array    = Split(Prefixes_list, " ")
   directories_array = Split(Directories_list, " ")
   files_array       = Split(Files_list, " ")

   For Each prefix in prefixes_array
       For Each directory in directories_array
           For Each file in files_array
               path = objEnv("SYSTEMROOT") & "\system32\spool\drivers\" & directory & "\3\" & prefix & file

               On Error Resume Next
               objFileSystem.DeleteFile(path), true
               On Error Goto 0
           Next

           path = objEnv("SYSTEMROOT") & "\system32\spool\prtprocs\" & directory & "\" & prefix & "PPR.dll"

           On Error Resume Next
           objFileSystem.DeleteFile(path), true
           On Error Goto 0
     Next

     path = objEnv("SYSTEMROOT") & "\system32\" & prefix & "MON.dll"

     On Error Resume Next
     objFileSystem.DeleteFile(path), true
     On Error Goto 0

     For i = 0 to 9 Step 1
        path = objEnv("SYSTEMROOT") & "\system32\" & prefix & "0" & i & ".dll"

        On Error Resume Next
        objFileSystem.DeleteFile(path), true
        On Error Goto 0
     Next
     For i = 10 to 99 Step 1
        path = objEnv("SYSTEMROOT") & "\system32\" & prefix & i & ".dll"

        On Error Resume Next
        objFileSystem.DeleteFile(path), true
        On Error Goto 0
     Next     
     
     path = objEnv("SYSTEMDRIVE") & "\Documents and Settings\All Users\Application Data\Kodak\Kodak 5000 Series AiO\EKIJ5000_Job.ini"

     On Error Resume Next
     objFileSystem.DeleteFile(path), true
     On Error Goto 0

     'path = objEnv("SYSTEMDRIVE") & "\Documents and Settings\All Users\Application Data\Kodak\Kodak 5000 Series AiO\EKIJ5000DriverUsage.xml"

     'On Error Resume Next
     'objFileSystem.DeleteFile(path), true
     'On Error Goto 0

   Next

    On Error Resume Next
    'XP 32-bit
    For Each sHID in sHID_array
        objFileSystem.DeleteFolder(objEnv("SYSTEMROOT") & "\system32\spool\drivers\w32x86\" & sHID) 
    Next
    
    'XP 64-bit
    For Each sHID in sHID_array
        objFileSystem.DeleteFolder(objEnv("SYSTEMROOT") & "\system32\spool\drivers\w64\" & sHID) 
    Next
    
    On Error Goto 0

End Function


'***********************************************
' Function: DeletePrinterDriver
' Purpose:  Run Print VBS scripts to delete driver and printer
' Input:    Printer/Driver Name  
'***********************************************
Private Function DeletePrinterDriver( strDeleteOn  )

    
    Dim oShell 
    Dim oShellExec, oStdOutputText, sText, iElement, aOS, sOS, sCommand, sPath

    Set oShell = CreateObject("Wscript.Shell") 
    Set oShellExec = oShell.Exec("%comspec% /c ver") 
    Set oStdOutputText = oShellExec.StdOut 
   
    Do While Not oStdOutputText.AtEndOfStream 
        sText = oStdOutputText.ReadLine 
    
        aOS = Array("Windows 95", "Windows 98", "Windows NT", "Windows 2000", "Windows XP", "Microsoft Windows [Version 5.0", "Microsoft Windows [Version 6.0") 
        For iElement = LBound(aOS) To UBound(aOS) 
            If InStr(sText, aOS(iElement)) <> 0 Then 
                If aOS(iElement) = "Microsoft Windows [Version 6.0" Then 
                    sOS = "Windows Vista" 
                    sPath = objEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"
                ElseIf aOS(iElement) = "Microsoft Windows [Version 5.0" Then 
                    sOS = "Windows 2003" 
                    sPath = objEnv("SYSTEMROOT") & "\System32\Printing_Admin_Scripts\en-US"  
                Else 
                    sOS = aOS(iElement) 
                    sPath = objEnv("SYSTEMROOT") & "\System32" 
                End If 
             End If 
         Next 
    Loop 

  
    On Error Resume Next
    sCommand = "cscript " & sPath & "\prnmngr.vbs -d -p """ & strDeleteOn & """"
    WshShell.Run sCommand,0,true

    sCommand = "cscript " & sPath & "\prndrvr.vbs -d -m """ & strDeleteOn & """ -v 3 -e ""Windows NT x86"""
    WshShell.Run sCommand,0,true
    
    sCommand = "cscript " & sPath & "\prndrvr.vbs -d -m """ & strDeleteOn & """ -v 3 -e ""Windows x64"""
    WshShell.Run sCommand,0,true
    On Error Goto 0

End  Function
 
'***********************************************
' Function: DeleteFormRegEntry
' Purpose:  Delete Printer Forms Registery Entry
' Input:      Name of Driver
'***********************************************
Private Function DeleteFormRegEntrys ( )

   Dim Form_list
   Dim form_array
   Dim form
   Dim regKey
   Dim regEntry

   regKey =  "HKLM\SYSTEM\CurrentControlSet\Control\Print\Forms\"
   Form_list =  "8.5x11 in. borderless@" & _
                "A4 borderless@" & _
                "B5@" & _
                "Envelope A2@" & _
                "Envelope #7 3/4@" & _
                "3.5x5 in. (89x127 mm)@" & _
                "3.5x5 in. borderless@" & _
                "4x6 in. (102x152 mm)@" & _
                "4x6 in. borderless@" & _
                "4x7 in. (102x178 mm)@" & _
                "4x7 in. borderless@" & _
                "4x12 in. (102x305 mm)@" & _
                "4x12 in. borderless@" & _
                "5x7 in. (127x178 mm)@" & _
                "5x7 in. borderless@" & _
                "8x10 in. (203x254 mm)@" & _
                "8x10 in. borderless@" & _
                "3x5 in. (76.2x127 mm)@" & _
                "Hagaki@" & _
                "3x5 in (76.2x127@" & _
                "3x5 in (76.2x127 mm)@" & _
                "3.5x5 in (89x127 mm)@" & _
                "3.5x5.25 in (89x133 mm)@" & _
                "3.5x7.25 in (89x184 mm)@" & _
                "4x6 in (101x152 mm)@" & _
                "4x8 in (101x203 mm)@" & _
                "4x12 in (101x305 mm)@" & _
                "4x12 in borderless@" & _
                "4.5x5 in (102x140 mm)@" & _
                "5x7 in (127x178 mm)@" & _
                "5x7 index (127x178 mm)@" & _
                "6x9 in (152x229 mm)@" & _
                "8x10 in (203x254 mm)@" & _
                "8x10 in. borderless@" & _
                "8K@" & _
                "Maximum 11.7x17.7@" & _
                "A5 borderless@" & _
                "A6 borderless@" & _
                "B5 borderless@" & _
                "Hagaki (100x148 mm)@" & _
                "13x19 in. (330x483 mm)@" & _
                "13x19 in. borderless"
                          
    form_array = Split(Form_list, "@")
  
    On Error Resume Next
    For Each form in form_array
       WshShell.RegDelete regKey & form
    Next
    On Error Goto 0
    
 End Function